"use strict";

const alumniSection = document.querySelector(".alumni-list");
const defaultValue = alumniSection.innerHTML;
const pageSize = 10;
let pageOffset = "";
let dataModified = "";
const loadMoreWrapper = document.querySelector(".load-more__wrapper");
const loadMorebtn = loadMoreWrapper.querySelector("#more-profiles");
const buttonText = loadMorebtn.querySelector(".monospace");
let defaultButtonText = loadMorebtn.innerHTML;
let defaultLayout = true;

// get data from airtable

const getAlumni = async function () {
  const baseID = "appbNQaekJNfW9BA1";
  const tableID = "tblCBMWtNuUxuby6U";
  const url = `https://api.airtable.com/v0/${baseID}/${tableID}?filterByFormula=%7BprofilePic%7D+!%3D+%22%22&pageSize=${pageSize}&sort%5B0%5D%5Bfield%5D=index&sort%5B0%5D%5Bdirection%5D=asc&offset=${pageOffset}`;

  const res = await fetch(url, {
    method: "GET",
    headers: {
      Authorization:
        "Bearer patPfPXQHQjj6iZqB.44b78b3271909a5877640a560f5e8d07a072cc2ad51ddfb8d63bd16a3c2da34c",
    },
  });
  const data = await res.json();
  // check if the offset value is present
  checkOffset(data);
  //modify the data
  dataModified = data.records.map((item) => {
    return item.fields;
  });
  drawElements(dataModified);
};

//on page load get alumni
getAlumni();

function drawElements(items) {
  if (defaultLayout) {
    alumniSection.innerHTML = "";
  }
  items.forEach((item) => {
    const newDiv = document.createElement("div");
    newDiv.innerHTML = `<a
    href="${item.linkedinProfile}"
    class="table-row is--img-thumbnail s-p-y-16 st-p-y-12 sm-p-y-12 is--relative overflow-none w-inline-block"
    ><div
      id="w-node-dd01ed5d-f344-a798-4978-a2ab2f0a58e4-92784656"
      class="table_img_wrapper sm-m-b-4"
    >
      <img
        src="${item.profilePic[0].url}"
        loading="lazy"
        id="w-node-_99a6527c-bb4a-e33f-e2b8-8b9fa8041341-92784656"
        sizes="(max-width: 767px) 11vw, (max-width: 991px) 8vw, 4vw"
        srcset="
        ${item.profilePic[0].url} 500w,
        ${item.profilePic[0].url}      568w
        "
      />
    </div>
    <p id="w-node-d2488c19-3789-29e8-e2bc-5673bd84f847-92784656">
      <strong>${item.firstName} ${item.lastName}</strong>
    </p>
    <div
      id="w-node-_60b61074-fe2b-2625-7c2c-128b9e1375eb-92784656"
      class="table-row__label-wrapper"
    >
      <div class="table__label p is--breaking-normal">
        ${item.organization}
      </div>
    </div>
    <div
      id="w-node-_93bf4dc7-aef9-b4e7-db31-fb730896e871-92784656"
      class="table-row__label-wrapper"
    >
      <div class="table__label p is--breaking-normal">${item.position}</div>
    </div>
    <div
      id="w-node-_103b8a69-45b6-465a-6088-340ffa0782c8-92784656"
      class="table-row__label-wrapper"
    >
      <div class="table__label p is--breaking-normal">${item.coursesTaken}</div>
    </div>
    <div
      id="w-node-_5c34cf68-578e-95ab-28f6-5a10f48ef649-92784656"
      class="arrow-wrapper is--flex-column"
    >
      <p
        class="button__arrow size-36"
        style="
          transform: translate3d(0%, 0%, 0px) scale3d(1, 1, 1) rotateX(0deg)
            rotateY(0deg) rotateZ(0deg) skew(0deg, 0deg);
          transform-style: preserve-3d;
        "
      >
        
      </p>
      <p
        class="button__arrow is--bottom size-36"
        style="
          transform: translate3d(-100%, 0%, 0px) scale3d(1, 1, 1) rotateX(0deg)
            rotateY(0deg) rotateZ(0deg) skew(0deg, 0deg);
          transform-style: preserve-3d;
        "
      >
        
      </p>
    </div>
    <div
      class="hover-bg bg-grey-2 only-desktop"
      style="
        transform: translate3d(0px, 102%, 0px) scale3d(1, 1, 1) rotateX(0deg)
          rotateY(0deg) rotateZ(0deg) skew(0deg, 0deg);
        transform-style: preserve-3d;
      "
    ></div
  ></a>  
  `;
    alumniSection.appendChild(newDiv);
  });

  loadMorebtn.innerHTML = defaultButtonText;
}

function checkOffset(data) {
  let hasOffset = false;
  "offset" in data ? (hasOffset = true) : (hasOffset = false);

  if (hasOffset) {
    pageOffset = data.offset;
    loadMoreWrapper.style.display = "flex";
  } else {
    pageOffset = "";
    loadMoreWrapper.style.display = "none";
  }
}

// load more
loadMorebtn.addEventListener("click", () => {
  defaultLayout = false;
  loadMorebtn.querySelector(".monospace").innerHTML = "Loading";
  getAlumni();
});
