window.addEventListener("DOMContentLoaded", () => {
  const heroTimeline = gsap.timeline({
    duration: 0.4,
    ease: "circ.inOut",
  });

  heroTimeline
    .from(".hero .hero__label .char", {
      x: "-110%",
      stagger: { amount: 0.4 },
    })
    .from(
      ".hero .hero__headline .char",
      {
        x: "-110%",
        stagger: { amount: 0.6 },
      },
      "-=0.4"
    )
    .from(
      [".hero h5 .char", ".hero h4 .char", ".hero h3 .char"],
      {
        x: "-110%",
        stagger: { amount: 0.4 },
      },
      "-=0.4"
    )
    .fromTo(
      [
        ".hero .tag",
        ".hero p ",
        ".hero h6",
        ".hero .key-value",
        ".hero .button-wrapper",
      ],
      {
        opacity: 0,
      },
      {
        ease: "circ.inOut",
        opacity: 1,
        stagger: { amount: 0.4 },
      },
      "-=0.6"
    )
    .fromTo(
      ".hero__content-wrapper .separator.is--vertical",
      { height: "0%" },
      { height: "100%" },
      "-=0.6"
    );
});
