const darkGrey6 = "#1c1c1c";

let topBarHeight = document.querySelector(".navbar").clientHeight;

const allSections = document.querySelectorAll(".container");
allSections.forEach((section) => {
  gsap.set(section, {
    scrollTrigger: {
      trigger: section,
      start: `top top+=${topBarHeight}px`,
      end: `bottom top+=${topBarHeight}px`,
      onEnter: () => check(section),
      onEnterBack: () => check(section),
      onLeave: () => check(section),
      onLeaveBack: () => check(section),
    },
  });
});

// "top bottom-=100px"

function check(section) {
  if (section.classList.contains("bg-dark-grey-6")) {
    navDark();
  } else {
    navLight();
  }
}

function navDark() {
  const navBg = document.querySelectorAll(".topbar");
  navBg.forEach((bg) => {
    bg.style.backgroundColor = "#1c1c1c";
  });

  const hoverBG = document.querySelectorAll(".navbar .hover-bg");
  hoverBG.forEach((bg) => {
    bg.style.backgroundColor = "#323232";
  });

  const navSvg = document.querySelectorAll(".logo__code, .navbar .monospace");
  navSvg.forEach((icon) => {
    icon.style.color = "white";
  });

  const navButton = document.querySelector(".topbar .pill-button");
  navButton.classList.add("is--dark");
}

function navLight() {
  const navBg = document.querySelectorAll(".topbar");
  navBg.forEach((bg) => {
    bg.style.backgroundColor = "white";
  });

  const hoverBG = document.querySelectorAll(".navbar .hover-bg");
  hoverBG.forEach((bg) => {
    bg.style.backgroundColor = "#f2f2f2";
  });

  const navSvg = document.querySelectorAll(".logo__code, .navbar .monospace");
  navSvg.forEach((icon) => {
    icon.style.color = "#1c1c1c";
  });

  const navButton = document.querySelector(".topbar .pill-button");
  navButton.classList.remove("is--dark");
}

window.addEventListener("DOMContentLoaded", () => {
  window.scroll(0, 1);
});
