const marqueeWrapper = document.querySelectorAll(
  ".logos__row-wrapper.marquee-wrapper"
);

marqueeWrapper.forEach((wrapper) => {
  // grab children of the wrapper
  const marqueeRow = wrapper.querySelector(".marquee-row");
  const rowWidth = marqueeRow.clientWidth;

  // get flex gap
  const wrapperStyle = window.getComputedStyle(wrapper);
  let gap = wrapperStyle.getPropertyValue("grid-column-gap");
  gap = parseFloat(gap, 10);

  const totalWidth = rowWidth + gap * 1.7;

  // append  3 copies of the row into wrapper
  for (i = 0; i < 2; i++) {
    wrapper.appendChild(marqueeRow.cloneNode(true));
  }

  // add gsap
  gsap.to(".logos__row-wrapper .marquee-row", {
    x: totalWidth * -1,
    repeat: -1,
    duration: 12,
    ease: "linear",
  });
});
