gsap.registerPlugin(ScrollTrigger);

const progCardSections = document.querySelectorAll(".container");
progCardSections.forEach((section) => {
  const progWrapper = section.querySelectorAll(".prog-card__wrapper");
  console.log(progWrapper);
  const progCardTL = gsap.timeline({
    scrollTrigger: {
      trigger: progWrapper,
      start: "start 75%",
    },
  });

  progWrapper.forEach((value) => {
    const curtain = value.querySelectorAll(".prog-img__curtain");
    const progIdentifier = value.querySelectorAll(".prog__identifier");
    const progTitle = value.querySelectorAll(".prog-card__title");
    const progDesc = value.querySelectorAll(".prog-card__desc");
    const separator = value.querySelectorAll(".separator");
    console.log(progIdentifier, progTitle, progDesc, separator);
    curtain.forEach((element) => {
      gsap.set(element, { display: "block" });
    });

    function scene() {
      const progTl = gsap.timeline({
        duration: 0.3,
        ease: "Power4.easeInOut",
      });

      progTl
        .to(curtain, { y: "101%", stagger: 1 })
        .from(
          [progIdentifier, progTitle, progDesc],
          {
            opacity: 0,
            y: "-20%",
          },
          "-=1"
        )
        .from(
          separator,
          {
            height: 0,
          },
          "-=0.1"
        );
      return progTl;
    }
    progCardTL.add(scene(), "-=1");
  });
});
