// check if the URL has parameters
checkTrackerStorage();

function checkTrackerStorage() {
  if (sessionStorage.getItem("utm_source") == null) {
    checkTrackers();
  } else {
    const source = sessionStorage.getItem("utm_source");
    const medium = sessionStorage.getItem("utm_medium");
    const campaign = sessionStorage.getItem("utm_campaign");
    appendTrackers(source, medium, campaign);
  }
}

function checkTrackers() {
  let url_string = window.location.href;
  let url = new URL(url_string);

  if (url.searchParams.get("utm_source") !== null) {
    retriveTrackers();
  } else {
    defaultTrackers();
  }
}

function retriveTrackers() {
  const url_string = window.location.href;
  const url = new URL(url_string);

  // store parameters in a variable
  let source = url.searchParams.get("utm_source");
  source = source.replace(/_/g, "-");
  source = source.replace(/\s/g, "");

  let medium = url.searchParams.get("utm_medium");
  medium = medium.replace(/_/g, "-");
  medium = medium.replace(/\s/g, "");

  let campaign = url.searchParams.get("utm_campaign");
  campaign = campaign.replace(/_/g, "-");
  campaign = campaign.replace(/\s/g, "");

  sessionStorage.setItem("utm_source", source);
  sessionStorage.setItem("utm_medium", medium);
  sessionStorage.setItem("utm_campaign", campaign);

  appendTrackers(source, medium, campaign);
}

function defaultTrackers() {
  const source = "direct";
  const medium = "website";
  const campaign = "none";

  sessionStorage.setItem("utm_source", source);
  sessionStorage.setItem("utm_medium", medium);
  sessionStorage.setItem("utm_campaign", campaign);

  appendTrackers(source, medium, campaign);
}

function appendTrackers(source, medium, campaign) {
  const links = document.querySelectorAll("a:not(.vertical-tab)");
  const currentPage = window.location.href.split("?")[0];

  links.forEach((link) => {
    //target url
    const target = link.href;
    if (link.href.includes("https://application.univ.ai")) {
      let combinedURL = `&i=univ_${source}_${medium}_${campaign}`;
      combinedURL = combinedURL.replace(/\s/g, "");
      link.href = link.href + combinedURL;
      link.addEventListener("click", (e) => {
        e.preventDefault();
        rdt("track", "Lead");
        fbq("track", "Purchase");
        window.location = link.href;
      });
    } else {
      if (
        target.split("#")[0] !== currentPage &&
        target.split("?")[0] !== currentPage
      ) {
        link.addEventListener("click", (e) => {
          e.preventDefault();
          setTimeout(() => {
            window.location = target;
          }, 1000);
          document.querySelector(".transition__trigger").click();
        });
      }
    }
  });
}
