let postsPerRow = 4;
let repeatPostPerRow = 2;
checkWindowSize();

window.addEventListener("resize", () => {
  checkWindowSize();
});

function checkWindowSize() {
  if (window.innerWidth > 1023) {
    postsPerRow = 4;
    repeatPostPerRow = 2;
    drawBlogPostsD();
  } else if (window.innerWidth > 767 && window.innerWidth < 1024) {
    postsPerRow = 2;
    repeatPostPerRow = 1;
    drawBlogPostsT();
  } else {
    drawBlogPostM();
  }
}

function drawBlogPostsD() {
  const blogCardSection = document.querySelectorAll(".variable-aspect-ratio");
  blogCardSection.forEach((section) => {
    const blogCardWrapper = section.querySelectorAll(".blog-card-wrapper");
    const totalBlogWrappers =
      Math.ceil(blogCardWrapper.length / postsPerRow) * repeatPostPerRow;

    //select every even item
    for (let i = 1; i < totalBlogWrappers; i++) {
      const imgWrapper =
        blogCardWrapper[0 + (i - 1) * 2].querySelector(".img-wrapper");
      imgWrapper.classList.add("aspect-ratio-1-1");
      imgWrapper
        .querySelector(".card__image")
        .classList.add("aspect-ratio-1-1");
    }

    //select every second item
    for (let i = 1; i < totalBlogWrappers - 1; i++) {
      const imgWrapper =
        blogCardWrapper[1 + (i - 1) * 2].querySelector(".img-wrapper");
      imgWrapper.classList.add("aspect-ratio-4-3");
      imgWrapper
        .querySelector(".card__image")
        .classList.add("aspect-ratio-4-3");
    }

    //select every fourth item
    for (
      let i = 1;
      i <= Math.ceil(blogCardWrapper.length / postsPerRow) - 1;
      i++
    ) {
      section
        .querySelectorAll(".blog-card-wrapper")
        [3 + (i - 1) * 4].querySelector(".separator")
        .classList.add("hide");
    }
  });
}

function drawBlogPostsT() {
  const blogCardSection = document.querySelectorAll(".variable-aspect-ratio");
  blogCardSection.forEach((section) => {
    const blogCardWrapper = section.querySelectorAll(".blog-card-wrapper");
    const totalBlogWrappers =
      Math.ceil(blogCardWrapper.length / postsPerRow) * repeatPostPerRow;

    console.log(totalBlogWrappers);

    //select every even item
    for (let i = 1; i <= totalBlogWrappers; i++) {
      const imgWrapper =
        blogCardWrapper[0 + (i - 1) * 2].querySelector(".img-wrapper");
      imgWrapper.classList.add("aspect-ratio-t-1-1");
      imgWrapper
        .querySelector(".card__image")
        .classList.add("aspect-ratio-t-1-1");
    }

    //select every second item
    for (let i = 1; i < totalBlogWrappers; i++) {
      const imgWrapper =
        blogCardWrapper[1 + (i - 1) * 2].querySelector(".img-wrapper");
      imgWrapper.classList.add("aspect-ratio-t-4-3");
      imgWrapper
        .querySelector(".card__image")
        .classList.add("aspect-ratio-t-4-3");

      section
        .querySelectorAll(".blog-card-wrapper")
        [1 + (i - 1) * 2].querySelector(".separator")
        .classList.add("hide");
    }
  });
}

function drawBlogPostM() {
  const blogCardWrapper = document.querySelectorAll(".blog-card-wrapper");
  blogCardWrapper.forEach((element) => {
    const imgWrapper = element.querySelector(".img-wrapper");
    imgWrapper.classList.add("aspect-ratio-m-4-3");
    imgWrapper
      .querySelector(".card__image")
      .classList.add("aspect-ratio-m-4-3");
  });
}
